Index: /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m (revision 934)
@@ -1,3 +1,4 @@
 % load data created by the MpdfDS_example
+clear all
 load pdfds_results
 
Index: /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 y = RV({'y'},1);
Index: /applications/bdmtoolbox/tutorial/userguide/mixef_basic.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/mixef_basic.m (revision 735)
+++ /applications/bdmtoolbox/tutorial/userguide/mixef_basic.m (revision 934)
@@ -1,2 +1,4 @@
+clear all
+
 com.class='ARX';
 com.rv = RV({'d'},[2],[0]);
Index: /applications/bdmtoolbox/tutorial/userguide/arx_selection_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_selection_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_selection_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % load data created by the pdfDS_example
 load pdfds_results
Index: /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m (revision 745)
+++ /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 y = RV({'y'},1);
@@ -30,5 +31,5 @@
 
 %%% store results
-Data=[M.DS_y'; M.DS_u'];
+Data=[M.DS_dt_y'; M.DS_dt_u'];
 drv = RVjoin([y,u]);
 true_theta=[fy.A fy.const]; 
Index: /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 y = RV({'y'},1);
Index: /applications/bdmtoolbox/tutorial/userguide/particle_ARX.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/particle_ARX.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/particle_ARX.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 x = RV({'x'},1);
Index: /applications/bdmtoolbox/tutorial/userguide/dist_estim_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/dist_estim_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/dist_estim_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 y = RV({'y'},1);
Index: /applications/bdmtoolbox/tutorial/userguide/frg_estim.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/frg_estim.m (revision 924)
+++ /applications/bdmtoolbox/tutorial/userguide/frg_estim.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % load data created by the MpdfDS_example
 load pdfds_results
Index: /applications/bdmtoolbox/tutorial/userguide/epdfds_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/epdfds_example.m (revision 933)
+++ /applications/bdmtoolbox/tutorial/userguide/epdfds_example.m (revision 934)
@@ -1,2 +1,4 @@
+clear all
+
 U.class = 'euni';
 U.high  = 1;
Index: /applications/bdmtoolbox/tutorial/userguide/memds_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/memds_example.m (revision 706)
+++ /applications/bdmtoolbox/tutorial/userguide/memds_example.m (revision 934)
@@ -1,2 +1,4 @@
+clear all
+
 DS.class='MemDS';
 DS.Data =[1 2 3 4 5 6];
Index: /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m (revision 871)
+++ /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m (revision 934)
@@ -1,2 +1,3 @@
+clear all
 % name random variables
 y = RV({'y'},1);
Index: /applications/bdmtoolbox/tutorial/userguide/lqg_control.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/lqg_control.m (revision 733)
+++ /applications/bdmtoolbox/tutorial/userguide/lqg_control.m (revision 934)
@@ -1,2 +1,4 @@
+clear all
+
 system.class ='mlnorm<chmat>';
 system.A     = [1 1 1];