Index: /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m (revision 934)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_ctrl_example.m (revision 968)
@@ -18,5 +18,5 @@
 % create ARX estimator
 A1.class = 'ARX';
-A1.rv = y;
+A1.yrv = y;
 A1.rgr = RVtimes([y,u1,u2],[-3,0,0]) ; % correct structure is {y,y}
 A1.log_level ='logbounds,logevidence';
Index: /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m (revision 934)
+++ /applications/bdmtoolbox/tutorial/userguide/dist_ctrl_example.m (revision 968)
@@ -18,7 +18,8 @@
 % create ARX estimator
 A1.class = 'ARX';
-A1.rv = y;
+A1.rv = RV({'theta','r'},[3,1]);
+A1.yrv = y;
 A1.rgr = RVtimes([y,u1],[-3,0]) ; % correct structure is {y,y}
-A1.log_level ='logbounds,logevidence';
+A1.log_level ='logbounds,logevidence,logmean';
 A1.frg = 0.95;
 
@@ -53,8 +54,8 @@
 hold off
 subplot(1,2,1);
-plot(M.DS_y);
+plot(M.DS_dt_y);
 subplot(1,2,2);
-plot(M.DS_u1); hold on;
-plot(M.DS_u2); 
+plot(M.DS_dt_u1); hold on;
+plot(M.DS_dt_u2); 
 
 figure(2);
Index: /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m (revision 964)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_basic_example.m (revision 968)
@@ -11,4 +11,5 @@
 A1.class = 'ARX';
 A1.yrv = y;
+A1.rv = RV({'theta','r'},[3,1]);
 A1.rgr = RVtimes([y,u],[-3,-1]) ; % correct structure is {y,y}
 A1.log_level = 'logbounds,logevidence';
Index: /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m (revision 944)
+++ /applications/bdmtoolbox/tutorial/userguide/pdfds_example.m (revision 968)
@@ -1,23 +1,27 @@
 clear all
 % name random variables
-x = RV({'x'},2);
+y = RV({'y'},1);
+u = RV({'u'},1);
 
+% create f(y_t| y_{t-3}, u_{t-1})
+fy.class = 'mlnorm<ldmat>';
+fy.rv    = y;
+fy.rvc   = RVtimes([y,u], [-3, -1]);
+fy.A     = [0.5, -0.9];
+fy.const = 0;
+fy.R     = 1e-2;
 
-fx.class  = 'mgnorm<ldmat>';             
-fx.rv     = x;             
-fx.rvc    = RVtimes(x,-1);             
-fx.g      = 'mexFunction';              % function is evaluated in matlab
-fx.g.function = 'test_function';         % name of the matlab function to evaluate
-fx.g.dim  = 2;                          % expected dimension of output
-fx.g.dimc = 2;                          % expected dimension of input
-fx.R      = eye(2);                     % variance R
-
+% create f(u_t| )
+fu.class = 'enorm<ldmat>';
+fu.rv    = u;
+fu.mu    = 0;
+fu.R     = 1e-1;
 
 % create DS
 DS.class = 'PdfDS';
 DS.pdf.class  = 'mprod';
-DS.pdf.pdfs  = {fx, fu};
-DS.init_rv = RVtimes([x], [-1]);
-DS.init_values = [0.1, 0.2];
+DS.pdf.pdfs  = {fy, fu};
+DS.init_rv = RVtimes([y,y,y], [-1,-2,-3]);
+DS.init_values = [0.1, 0.2, 0.3];
 
 experiment.ndat=100;
Index: /applications/bdmtoolbox/tutorial/userguide/laplace_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/laplace_example.m (revision 944)
+++ /applications/bdmtoolbox/tutorial/userguide/laplace_example.m (revision 968)
@@ -19,3 +19,3 @@
 %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
 % plot results
-plot(M.L_mean)
+plot(M.Est0_apost_mean_)
Index: /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m
===================================================================
--- /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m (revision 934)
+++ /applications/bdmtoolbox/tutorial/userguide/arx_windsurfer_example.m (revision 968)
@@ -17,5 +17,5 @@
 % create ARX estimator
 A1.class = 'ARX';
-A1.rv = y;
+A1.yrv = y;
 A1.rgr = RVtimes([y,u],[-3,-1]) ; % correct structure is {y,y}
 A1.log_level ='logbounds,logevidence';